{ CHAN.INC

  Parallel Pascal v. 2.0.2: Copyright (c) 1989 3L Ltd

  This file, when added to a program with the $INCLUDE statement,
  provides access to the CHAN package for channel communication.

  Rev 005 09-Mar-89  JF  For version 2.0.2
}

{ TYPE and CONST definitions }
CONST  Upper_Limit = 500;          { Guess at upper limit of channels }
       NotProcess_P = 16_80000000; { Value channel words are initialised with }
TYPE   Chan_Type   = ^Integer;
       Chan_Vec    = ARRAY [0 .. Upper_Limit] OF ^Chan_Type;

{ Number of input and output ports... }
IMPORT  In_Ports ALIAS 'IMP_INPUT_VECLEN'  : Integer;
IMPORT Out_Ports ALIAS 'IMP_OUTPUT_VECLEN' : Integer;

{ ...and the channel vectors themselves }
IMPORT  In_Chan ALIAS 'IMP_INPUT_CHANNEL'  : ^ Chan_Vec;
IMPORT Out_Chan ALIAS 'IMP_OUTPUT_CHANNEL' : ^ Chan_Vec;

{ Example of use of the above: output 'a' to channel 1:
     Chan_Out_Byte('a', Out_Chan^[1]^);
}

{ The channels associated with the hardware Inmos links }
IMPORT Link0Output ALIAS 'P_Link0Output' : ^ Chan_Type;
IMPORT Link1Output ALIAS 'P_Link1Output' : ^ Chan_Type;
IMPORT Link2Output ALIAS 'P_Link2Output' : ^ Chan_Type;
IMPORT Link3Output ALIAS 'P_Link3Output' : ^ Chan_Type;
IMPORT Link0Input  ALIAS 'P_Link0Input'  : ^ Chan_Type;
IMPORT Link1Input  ALIAS 'P_Link1Input'  : ^ Chan_Type;
IMPORT Link2Input  ALIAS 'P_Link2Input'  : ^ Chan_Type;
IMPORT Link3Input  ALIAS 'P_Link3Input'  : ^ Chan_Type;
{ ...and the channel associated with external events }
IMPORT EventReq    ALIAS 'P_EventReq'    : ^ Chan_Type;

{ Example of use of the above: output 'a' to link 0:
     Chan_Out_Byte('a', Link0Output^);
}


{ IMPORT statements for the various procedures }
IMPORT PROCEDURE Chan_In_Byte ALIAS 'chan_in_byte' 
   (VAR B : UNIV Char; VAR Chan : Chan_Type);

IMPORT FUNCTION Chan_In_Byte_T ALIAS 'chan_in_byte_t' 
   (VAR B : UNIV Char; VAR Chan : Chan_Type; Timeout : Integer) : Boolean;

IMPORT PROCEDURE Chan_Init ALIAS 'chan_init'
   (VAR Chan : Chan_Type);

IMPORT PROCEDURE Chan_In_Message ALIAS 'chan_in_message'
   (L : Integer; VAR B : UNIV Char; VAR Chan : Chan_Type);

IMPORT FUNCTION Chan_In_Message_T ALIAS 'chan_in_message_t'
   (L : Integer; VAR B : UNIV Char;
    VAR Chan : Chan_Type; Timeout : Integer) : Boolean;

IMPORT PROCEDURE Chan_In_Word ALIAS 'chan_in_word'
   (VAR W : Integer; VAR Chan : Chan_Type);

IMPORT FUNCTION Chan_In_Word_T ALIAS 'chan_in_word_t'
   (VAR W : Integer; VAR Chan : Chan_Type; Timeout : Integer) : Boolean;

IMPORT PROCEDURE Chan_Out_Byte ALIAS 'chan_out_byte'
   (B : UNIV Char; VAR Chan : Chan_Type);

IMPORT FUNCTION Chan_Out_Byte_T ALIAS 'chan_out_byte_t'
   (B : UNIV Char; VAR Chan : Chan_Type; Timeout : Integer) : Boolean;

IMPORT PROCEDURE Chan_Out_Message ALIAS 'chan_out_message'
   (L : Integer; VAR B : UNIV Char; VAR Chan : Chan_Type);

IMPORT FUNCTION Chan_Out_Message_T ALIAS 'chan_out_message_t'
   (L : Integer; VAR B : UNIV Char;
    VAR Chan : Chan_Type; Timeout : Integer) : Boolean;

IMPORT PROCEDURE Chan_Out_Word ALIAS 'chan_out_word'
   (W : Integer; VAR Chan : Chan_Type);

IMPORT FUNCTION Chan_Out_Word_T ALIAS 'chan_out_word_t'
   (W : Integer; VAR Chan : Chan_Type; Timeout : Integer) : Boolean;

IMPORT FUNCTION Chan_Reset ALIAS 'chan_reset'
   (VAR Chan : Chan_Type) : Integer;
