{ DOS.INC

  Parallel Pascal v. 2.0.1: Copyright (c) 1989 3L Ltd.

  This file, when added to a program with the $INCLUDE statement,
  provides access to procedures for controlling the host MS-DOS
  machine.   These procedures have functions similar to those
  available to the Microsoft C programmer.

  Rev 005  24-Feb-89  JF    For version 2.0.1


  Note the following differences from a "real" PC implementation:
 
  1) The registers are in a different order to the order used
     by Microsoft: the order is that used by the Inmos server.
  2) The HOSTWORD type used for defining the 16-bit registers have
     the range 0..16_FFFF.   However, on the transputer, they
     in fact occupy 4 bytes: only the low-order 2 are used.
  3) The segment registers are available in the WORDREGS and REGS
     formats but are not usable by the programmer; they are included
     to simplify the work of the interrupt routines.
  4) CFLAG is not used, only set.
  5) The type PCPOINTER is available to define an 8086 far pointer;
     the top 16 bits of this are the segment number, the low 16 are
     the offset, e.g.:

         VAR
            X   : PCPointer;
            R   : Regs;
            S   : SRegs;
         BEGIN
            S.DS := X >> 16;
            R.X.DX := X & 16_FFFF;
}

{ Definitions of types we need }
TYPE HostByte  = 0..255;
TYPE HostWord  = 0..16_FFFF;
TYPE PCPointer = Integer;
TYPE DummyByte = Char;
TYPE CValue    = 0..1;


{ SREGS: Segment registers }
TYPE SRegs = RECORD
                CS, DS, ES, SS : HostWord
             END;


{ WORDREGS: Word registers }
TYPE WordRegs = RECORD
                   AX, BX, CX, DX, DI, SI : HostWord;
                   S                      : SRegs;
                   CFlag                  : CValue;
                   DB1, DB2, DB3          : DummyByte    
                END;


{ BYTEREGS: Byte registers.  Enough dummies are included so that they
            will overlay the word registers correctly.  }
TYPE ByteRegs = RECORD
                   AL, AH                : HostByte;
                   DB1, DB2              : DummyByte;
                   BL, BH                : HostByte;
                   DB3, DB4              : DummyByte;
                   CL, CH                : HostByte;
                   DB5, DB6              : DummyByte;
                   DL, DH                : HostByte;
                   DB7, DB8              : DummyByte
                END;


{ REGS: All the registers }
TYPE Register_Size = (Byte_Size, Word_Size);
TYPE Regs = RECORD
               CASE Register_Size OF
                  Byte_Size: (H : ByteRegs);
                  Word_Size: (X : WordRegs)
            END;


{ IMPORT statements for the various procedures }
IMPORT FUNCTION Int86 ALIAS 'int86'
   ( IntNo : Integer; VAR InRegs,OutRegs : Regs ) : Integer;
  
IMPORT FUNCTION Int86x ALIAS 'int86x'
   ( IntNo : Integer; VAR InRegs,OutRegs : Regs; VAR SegRegs : SRegs ) : Integer;

IMPORT PROCEDURE SegRead ALIAS 'segread'
   ( VAR SegRegs : SRegs );

IMPORT FUNCTION IntDos ALIAS 'intdos'
   ( VAR InRegs, OutRegs : Regs ) : Integer;

IMPORT FUNCTION IntDosX ALIAS 'intdosx'
   ( VAR InRegs, OutRegs : Regs; VAR SegRegs : SRegs ) : Integer;

IMPORT FUNCTION BDos ALIAS 'bdos'
   ( DosFn, DosDX, DosAL  : Integer ) : Integer;

IMPORT FUNCTION Alloc86 ALIAS 'alloc86'
   ( Number_of_Bytes : Integer ) : PCPointer;

IMPORT PROCEDURE Free86 ALIAS 'free86'
   ( Location : PCPointer );

IMPORT FUNCTION To86 ALIAS 'to86'
   ( Len : Integer; VAR Here : UNIV Char; There : PCPointer ) : Integer;

IMPORT FUNCTION From86 ALIAS 'from86'
   ( Len : Integer; There : PCPointer; VAR Here : UNIV Char ) : Integer;

