{ CGA.PAS

  Parallel Pascal v. 2.0A: Copyright (c) 1988 3L Ltd
  Primitives for CGA graphics

  Rev 000  27-Jul-88  JF    Created

  NB: Requires compilation with the /X switch.
}

MODULE CGA;

$INCLUDE '\TP2V0\DOS.INC'

{ Useful types and constants }
CONST
   Mono_80col_Text_Mode    =  16_02;
   Cga_Lores_Graphics_Mode =  16_05;
   Cga_Hires_Graphics_Mode =  16_06;
   Dont_Clear_Display      =  16_80;
   Display_Buffer          =  16_B8000000;
   Max_CGA_Y               =  199;
   Max_CGA_HiRes_X         =  639;
   Max_CGA_LoRes_X         =  319;

TYPE
   Byte                    =  0..255;
   Plane_Selector          =  0..1;
   Row_Selector            =  0..99;
   Byte_Selector           =  0..79;
   Colour                  =  0..3;
   CGA_Y                   =  0..Max_CGA_Y;
   CGA_HiRes_X             =  0..Max_CGA_HiRes_X;
   CGA_LoRes_X             =  0..Max_CGA_LoRes_X;
   Display_Plane           =
      RECORD
         CASE Boolean OF
            True:   (Flat    : ARRAY [1..16_2000] OF Byte);
            False:  (Bytes   : ARRAY [Row_Selector, Byte_Selector] OF Byte)
      END;

{ The display buffer }
STATIC
   CGABuf   : ARRAY [Plane_Selector] OF Display_Plane;
CONST
   Display_Buffer_Length       =  16384;

{ Send the whole buffer to the display }
EXPORT PROCEDURE CGA_Update;
VAR
   DB       : PCPointer;
   Dummy    : Integer;
BEGIN
   DB := Display_Buffer;
   Dummy := To86 (Display_Buffer_Length, CGABuf, DB)
END;


{ Set a video mode }
EXPORT PROCEDURE Video_Mode (Mode : Integer);
CONST
   Video_Set_Mode    = 0;
   BIOS_Video_Driver = 16;
VAR
   R                 : Regs;
   I, Dummy          : Integer;
BEGIN
   IF (Mode & Dont_Clear_Display) = 0 THEN BEGIN
      FOR I := 1 TO 16_2000 DO CGABuf[0].Flat[I] := 0;
      CGABuf[1] := CGABuf[0];
   END;
   R.H.AH := Video_Set_Mode;
   R.H.AL := Mode;
   Dummy := Int86 (BIOS_Video_Driver, R, R)
END;

         
{ High-resolution plot }
EXPORT PROCEDURE CGA_HiRes_Plot (X : CGA_HiRes_X; Y : CGA_Y);
VAR
   P        : Plane_Selector;
   R        : Row_Selector;
   B        : Byte_Selector;
   Bits     : Byte;
BEGIN
   P := Y & 1;
   R := Y >> 1;
   B := X >> 3;
   Bits := 16_80 >> (X & 7);
   CGABuf[P].Bytes[R,B] := CGABuf[P].Bytes[R,B] | Bits;
END;

{ Low-resolution plot }
EXPORT PROCEDURE CGA_LoRes_Plot (X : CGA_LoRes_X; Y : CGA_Y; C : Colour);
VAR
   P          : Plane_Selector;
   R          : Row_Selector;
   B          : Byte_Selector;
   Shift      : 0..6;
BEGIN
   P := Y & 1;
   R := Y >> 1;
   B := X >> 2;
   Shift := (3 - (X&3)) * 2;
   CGABuf[P].Bytes[R, B] := 
      (CGABuf[P].Bytes[R,B] & (~(3<<Shift))) | (C<<Shift);
END;

END.
