{ MANDELW.PAS
 
  Parallel Pascal v. 2.0A: Copyright (c) 1988 3L Ltd
  Example program: Mandelbrot set evaluation and display
 
  Worker task
  Rev 000  28-Jul-88  JF    Created
  Rev 001  10-Feb-89  JF    Changes for version 2.0.1
 
  The application
  ---------------
 
  For details of the application in general, see the top of MANDELM.PAS.
 
  Internals of MANDELW
  --------------------
 
  The task waits till a packet arrives.   This is a record of type
  COMMAND, as defined in MANDEL.INC, and contains details of the portion
  of the Mandelbrot to do.   The task then does the work, and stores the
  results in a record of type RESULTS, which is then sent back to 
  MANDELM.

  Notice that MANDELW will be linked with the stand-alone library, since
  it does not communicate directly with the afserver.   Consequently, it
  is not a full Pascal program, but is coded as a MODULE.
} 

MODULE MandelW;

$INCLUDE 'NET.INC'
$INCLUDE 'CGA.INC'
$INCLUDE 'MANDEL.INC'

STATIC C                        : Command;
STATIC R                        : Results;

PROCEDURE Worker;
VAR
   X                            : CGA_LoRes_X;
   Y                            : CGA_Y;
   Count, N                     : Integer;
   Complete                     : Boolean;
   Gap, X_Coord, Y_Coord,
   AC, BC, Sq, A2, B2, A, B     : ShortReal;

BEGIN
   WHILE TRUE DO BEGIN     { Endless loop }

      { Wait here till packet arrives }
      N := Net_Receive (C, Complete);      
      { Unpack some of the parameters }
      X_Coord := C.Details.X_Coord;
      Y_Coord := C.Details.Y_Coord;
      Gap := C.Details.Gap;

      { Top-left and bottom-right corners specified which part to do }
      N := 1;
      FOR Y := C.T.Tly TO C.T.Bry DO BEGIN
         BC := Y_Coord - Y*Gap;
         FOR X := C.T.Tlx TO C.T.Brx DO BEGIN
            AC := X*Gap + X_Coord;
            A := AC; B := BC; Sq := 0; Count := 0;
            { Do calculation until > 2 away, or count reaches 256 }
            A2 := A*A; B2 := B*B;
            WHILE (Sq < 4) AND (Count < 256) DO BEGIN
               B := 2*A*B + BC;
               A := A2 - B2 + AC;
               A2 := A*A; B2 := B*B;
               Sq := A2 + B2;
               Count := Count + 1;
            END;
            { Store 0 means 1; stored 255 means 256 }
            R.Counts[N] := Count - 1;
            N := N + 1
         END            
      END;
      { Send top-left and bottom-right coordinates back to MANDELM
        as well, to identify the data...                           }
      R.T := C.T;
      Net_Send (Size(Tile)+N, R, True)
   
   END   { of endless loop }
END;  
 
{ Start here and immediately call working procedure }
BEGIN
   Worker
END.
